<div class="analytics-tokens">
  <h1 i18n="Analytics Tokens | Header text analytics tokens page @@headerAnalyticsTokens">
    Analytics Tokens
  </h1>
  <button
    class="create-token-button"
    (click)="onCreateAnalyticsTokenClick()"
    nz-button
    i18n="Create Token | Button Text @@createAnalyticsToken">
    Create Token
  </button>
  <div>
    <nz-table #tokensTable
              [nzData]="this.analyticTokens"
              class="tokens-table">
      <thead>
      <tr>
        <th></th>
        <th>Name</th>
        <th>Token</th>
        <th i18n="Created At | Table column header @@createdAt">Created At</th>
        <th i18n="Expires | Table column header @@expires">Expires</th>
      </tr>
      </thead>
      <tbody>
        <ng-container *ngFor="let analyticToken of tokensTable.data">
          <tr>
            <td [nzExpand]="expandSet.has(analyticToken.id)"
                (nzExpandChange)="onExpandChange(analyticToken.id, $event)"></td>
            <td>{{ analyticToken.name }}</td>
            <td>
              <div class="token-info">
                <div class="abbr">{{ analyticToken.key | slice : 0 : 8 }}...</div>
                <nz-tag *ngIf="analyticToken.isExpired">Expired</nz-tag>
              </div>
            </td>
            <td>{{ analyticToken.created | date }}</td>
            <td>{{ analyticToken.expires ? (analyticToken.expires | date) : 'never' }}</td>
          </tr>
          <tr [nzExpand]="expandSet.has(analyticToken.id)">
            <td [attr.colspan]="columnsToDisplayWithExpand.length">
              <div class="example-element-detail">
                <div class="token-expanded-details">
                  <div class="action-buttons">
                    <input hidden="true"
                           #fileInput type="file"
                           (change)="uploadFileChanged($event)"
                           accept="image/png, image/jpeg"
                    />
                    <span *ngIf="selectedFile" class="file-indicator">
                      {{ selectedFile.name }}
                      <fa-icon [icon]="faTimes" (click)="this.selectedFile = null"></fa-icon>
                    </span>
                    <button
                      nz-button
                      nzType="primary"
                      (click)="onUploadButtonClick()">
                      <span i18n="@@uploadButton" *ngIf="!selectedFile">Select new image</span>
                      <span i18n="@@uploadButtonDoUpload" *ngIf="selectedFile">Upload selected image</span>
                    </button>
                    <button
                      nz-button
                      nzType="default"
                      *ngIf="!analyticToken.isExpired"
                      (click)="copyTokenToClipboard(analyticToken.key)"
                      i18n="Copy Token @@copyToken">
                      Copy Token
                    </button>
                    <button
                      nz-button
                      nzType="dashed"
                      (click)="onDeleteTokenClick(analyticToken.id)"
                      i18n="Delete Token @@deleteToken">
                      Delete Token
                    </button>
                  </div>
                  <div *ngIf="getExpandedElement()?.image_path">
                    <img height="200px" [src]="getImageSource()" alt="token image"/>
                  </div>
                  <br />
                  <div *ngIf="!analyticToken.isExpired">
                    <h2
                      i18n="Available Verbs | Table Expanded Row Header @@availbaleVerbsHeader">
                      Available Verbs
                    </h2>
                    <div *ngFor="let providerDef of availableAnalyticTokenVerbs">

                      <h2>{{ providerDef.label }}</h2>

                      <nz-list>
                        <nz-list-item *ngFor="let verb of providerDef.analyticTokenVerbs">
                          <label nz-checkbox
                            (ngModelChange)="onSelectionChanged(verb, providerDef.providerId)"
                            [ngModel]="isVerbSelected(verb, providerDef.providerId)"
                          >
                            {{ verb.label }}
                          </label>
                        </nz-list-item>
                      </nz-list>
                    </div>
                    <br />
                    <div class="save-active-verbs-btn">
                      <button
                        nz-button
                        nzType="primary"
                        (click)="saveActiveVerbs()"
                        i18n="Save @@save">
                        Save
                      </button>
                    </div>
                  </div>

                  <h2
                    i18n="
                                      Accessible Engines | Table Expanded Row Header
                                      @@accessibleEnginesHeader">
                    Accessible Engines
                  </h2>
                  <h5
                    i18n="
                                      Accessible Engines Description @@accessibleEnginesDescription">
                    List of analysis engines whose results can be used in as the input
                    of the selected analysis engine.
                  </h5>
                  <nz-list>
                    <nz-list-item *ngFor="let token of analyticToken.can_access">
                      <label nz-checkbox
                        [(ngModel)]="token.selected">
                        {{ token.name }}
                      </label>
                    </nz-list-item>
                  </nz-list>

                  <br />
                  <div class="save-active-verbs-btn">
                    <button
                      nz-button
                      nzType="primary"
                      (click)="saveEngineResultAccess(analyticToken.id)"
                      i18n="Save @@save">
                      Save
                    </button>
                  </div>
                </div>
              </div>
            </td>
          </tr>
        </ng-container>
      </tbody>
    </nz-table>
  </div>
</div>
